/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.85 Revision 1.150
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.85 2010/11/10 13:45:38 wired Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.150 2013/08/13 10:17:54 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.digia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
39 SRC_URI="http://download.qt-project.org/official_releases/qt/${PV%.*}/${PV}/${MY_P}.tar.gz"
40 ;;
41esac
42
43IUSE="aqua debug pch"
44[[ ${CATEGORY}/${PN} != dev-qt/qtwebkit ]] && IUSE+=" c++0x"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 45[[ ${CATEGORY}/${PN} != dev-qt/qtxmlpatterns ]] && IUSE+=" +exceptions"
21else 46
22 MY_P=qt-x11-opensource-src-${MY_PV} 47DEPEND="virtual/pkgconfig"
48if [[ ${QT4_BUILD_TYPE} == live ]]; then
49 DEPEND+=" dev-lang/perl"
23fi 50fi
24 51
25HOMEPAGE="http://qt.nokia.com/"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
27
28LICENSE="|| ( LGPL-2.1 GPL-3 )"
29IUSE+=" debug pch aqua"
30
31RDEPEND="
32 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999
34 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999
36 !<x11-libs/qt-dbus-${PV}
37 !>x11-libs/qt-dbus-${PV}-r9999
38 !<x11-libs/qt-demo-${PV}
39 !>x11-libs/qt-demo-${PV}-r9999
40 !<x11-libs/qt-gui-${PV}
41 !>x11-libs/qt-gui-${PV}-r9999
42 !<x11-libs/qt-multimedia-${PV}
43 !>x11-libs/qt-multimedia-${PV}-r9999
44 !<x11-libs/qt-opengl-${PV}
45 !>x11-libs/qt-opengl-${PV}-r9999
46 !<x11-libs/qt-phonon-${PV}
47 !>x11-libs/qt-phonon-${PV}-r9999
48 !<x11-libs/qt-qt3support-${PV}
49 !>x11-libs/qt-qt3support-${PV}-r9999
50 !<x11-libs/qt-script-${PV}
51 !>x11-libs/qt-script-${PV}-r9999
52 !<x11-libs/qt-sql-${PV}
53 !>x11-libs/qt-sql-${PV}-r9999
54 !<x11-libs/qt-svg-${PV}
55 !>x11-libs/qt-svg-${PV}-r9999
56 !<x11-libs/qt-test-${PV}
57 !>x11-libs/qt-test-${PV}-r9999
58 !<x11-libs/qt-webkit-${PV}
59 !>x11-libs/qt-webkit-${PV}-r9999
60 !<x11-libs/qt-xmlpatterns-${PV}
61 !>x11-libs/qt-xmlpatterns-${PV}-r9999
62"
63
64S=${WORKDIR}/${MY_P} 52S=${WORKDIR}/${MY_P}
65 53
66# @FUNCTION: qt4-build_pkg_setup 54# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 55# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 56# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 57qt4-build_pkg_setup() {
70 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
71
72 # Protect users by not allowing downgrades between releases 58 # Protect users by not allowing downgrades between releases.
73 # Downgrading revisions within the same release should be allowed 59 # Downgrading revisions within the same release should be allowed.
74 if has_version '>'${CATEGORY}/${P}-r9999 ; then 60 if has_version ">${CATEGORY}/${P}-r9999:4"; then
75 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 61 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
76 eerror "Sanity check to keep you from breaking your system:" 62 eerror " *** Sanity check to keep you from breaking your system ***"
77 eerror " Downgrading Qt is completely unsupported and will break your system!" 63 eerror "Downgrading Qt is completely unsupported and will break your system!"
78 die "aborting to save your system" 64 die "aborting to save your system"
79 else 65 else
80 ewarn "Downgrading Qt is completely unsupported and will break your system!" 66 ewarn "Downgrading Qt is completely unsupported and will break your system!"
81 fi 67 fi
82 fi
83
84 if [[ "${PN}" == "qt-webkit" ]]; then
85 eshopts_push -s extglob
86 if is-flagq '-g?(gdb)?([1-9])'; then
87 echo
88 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
89 ewarn "You may experience really long compilation times and/or increased memory usage."
90 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
91 ewarn "For more info check out bug #307861"
92 echo
93 fi
94 eshopts_pop
95 fi 68 fi
96 69
97 PATH="${S}/bin${PATH:+:}${PATH}" 70 PATH="${S}/bin${PATH:+:}${PATH}"
98 if [[ ${CHOST} != *-darwin* ]]; then 71 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 72 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
104 # avoid extract failure. 77 # avoid extract failure.
105 [[ ${CHOST} == *-apple-darwin* ]] && \ 78 [[ ${CHOST} == *-apple-darwin* ]] && \
106 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 79 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
107 ${QT4_EXTRACT_DIRECTORIES}" 80 ${QT4_EXTRACT_DIRECTORIES}"
108 fi 81 fi
109
110 # Make sure ebuilds use the required EAPI
111 if [[ ${EAPI} != [23] ]]; then
112 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
113 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
114 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
115 die "qt4-build eclass requires EAPI=2 or EAPI=3"
116 fi
117
118 if ! version_is_at_least 4.1 $(gcc-version); then
119 ewarn "Using a GCC version lower than 4.1 is not supported!"
120 fi
121} 82}
83
84# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
85# @DEFAULT_UNSET
86# @DESCRIPTION:
87# Space-separated list including the directories that will be extracted from
88# Qt tarball.
122 89
123# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 90# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
91# @DEFAULT_UNSET
124# @DESCRIPTION: 92# @DESCRIPTION:
125# Arguments for build_target_directories. Takes the directories, in which the 93# Arguments for build_target_directories. Takes the directories in which the
126# code should be compiled. This is a space-separated list 94# code should be compiled. This is a space-separated list.
127
128# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
129# @DESCRIPTION:
130# Space separated list including the directories that will be extracted from Qt
131# tarball
132 95
133# @FUNCTION: qt4-build_src_unpack 96# @FUNCTION: qt4-build_src_unpack
134# @DESCRIPTION: 97# @DESCRIPTION:
135# Unpacks the sources 98# Unpacks the sources.
136qt4-build_src_unpack() { 99qt4-build_src_unpack() {
137 setqtenv 100 setqtenv
138 local target targets= 101
102 if ! version_is_at_least 4.1 $(gcc-version); then
103 ewarn "Using a GCC version lower than 4.1 is not supported."
104 elif use_if_iuse c++0x && ! version_is_at_least 4.4 $(gcc-version); then
105 ewarn "USE=c++0x requires GCC 4.4 or later."
106 fi
107
108 if [[ ${CATEGORY}/${PN} == dev-qt/qtwebkit ]]; then
109 eshopts_push -s extglob
110 if is-flagq '-g?(gdb)?([1-9])'; then
111 echo
112 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
113 ewarn "You may experience really long compilation times and/or increased memory usage."
114 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
115 ewarn "For more info check out https://bugs.gentoo.org/307861"
116 echo
117 fi
118 eshopts_pop
119 fi
120
121 case ${QT4_BUILD_TYPE} in
122 live)
123 git-2_src_unpack
124 ;;
125 release)
126 local tarball="${MY_P}.tar.gz" target= targets=
139 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 127 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
140 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 128 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
141 ${QT4_EXTRACT_DIRECTORIES}; do 129 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
130 do
142 targets+=" ${MY_P}/${target}" 131 targets+="${MY_P}/${target} "
143 done 132 done
144 133
134 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
145 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 135 tar -xzf "${DISTDIR}/${tarball}" ${targets}
146 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 136 eend $? || die "failed to unpack"
137 ;;
138 esac
147} 139}
148 140
149# @ECLASS-VARIABLE: PATCHES 141# @ECLASS-VARIABLE: PATCHES
142# @DEFAULT_UNSET
150# @DESCRIPTION: 143# @DESCRIPTION:
151# In case you have patches to apply, specify them in PATCHES variable. Make sure 144# PATCHES array variable containing all various patches to be applied.
152# to specify the full path. This variable is necessary for src_prepare phase. 145# This variable is expected to be defined in global scope of ebuild.
153# example: 146# Make sure to specify the full path. This variable is utilised in
154# PATCHES="${FILESDIR}"/mypatch.patch 147# src_prepare() phase.
155# ${FILESDIR}"/mypatch2.patch"
156# 148#
149# @CODE
150# PATCHES=( "${FILESDIR}/mypatch.patch"
151# "${FILESDIR}/patches_folder/" )
152# @CODE
157 153
158# @FUNCTION: qt4-build_src_prepare 154# @FUNCTION: qt4-build_src_prepare
159# @DESCRIPTION: 155# @DESCRIPTION:
160# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 156# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
161# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 157# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in make.conf.
162qt4-build_src_prepare() { 158qt4-build_src_prepare() {
163 setqtenv 159 setqtenv
164 cd "${S}" 160
165 161 if [[ ${QT4_BUILD_TYPE} == live ]]; then
166 # fix qt 4.7 regression that skips -fvisibility=hidden 162 QTDIR="." ./bin/syncqt || die "syncqt failed"
167 if version_is_at_least "4.7.0_beta1"; then
168 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
169 -i config.tests/unix/fvisibility.test ||
170 die "visibility fixing sed failed"
171 fi 163 fi
164
172 # fix libx11 dependency on non X packages 165 # avoid X11 dependency in non-gui packages
173 if version_is_at_least "4.7.0_beta2"; then
174 local NOLIBX11PKG="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 166 local nolibx11_pkgs="qtcore qtdbus qtscript qtsql qttest qtxmlpatterns"
175 hasq ${PN} ${NOLIBX11PKG} && qt_nolibx11 167 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
176 [[ ${PN} == "qt-assistant" ]] && qt_assistant_cleanup
177 fi
178 168
179 if use aqua; then 169 if use aqua; then
180 # provide a proper macx-g++-64 170 # provide a proper macx-g++-64
181 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 171 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
182 172
183 sed -e '/^CONFIG/s:app_bundle::' \ 173 sed -e '/^CONFIG/s:app_bundle::' \
184 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 174 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
185 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 175 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
186 fi 176 fi
187 177
188 if [[ ${PN} != qt-core ]]; then 178 if [[ ${CATEGORY}/${PN} != dev-qt/qtcore ]]; then
189 skip_qmake_build_patch 179 skip_qmake_build
190 skip_project_generation_patch 180 skip_project_generation
191 symlink_binaries_to_buildtree 181 symlink_binaries_to_buildtree
192 fi 182 fi
193 183
194 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 184 if use_if_iuse c++0x; then
195 # qmake bus errors with -O2 but -O3 works 185 append-cxxflags -std=c++0x
196 replace-flags -O2 -O3
197 fi
198
199 # Bug 178652
200 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
201 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
202 append-flags -fno-gcse
203 fi
204
205 # Unsupported old gcc versions - hardened needs this :(
206 if [[ $(gcc-major-version) -lt 4 ]] ; then
207 ewarn "Appending -fno-stack-protector to CXXFLAGS"
208 append-cxxflags -fno-stack-protector
209 # Bug 253127
210 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
211 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
212 fi 186 fi
213 187
214 # Bug 261632 188 # Bug 261632
215 if use ppc64; then 189 if use ppc64; then
216 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
217 append-flags -mminimal-toc 190 append-flags -mminimal-toc
218 fi 191 fi
219 192
220 # Bug 282984 && Bug 295530 193 # Bug 373061
221 sed -e "s:\(^SYSTEM_VARIABLES\):CC="$(tc-getCC)"\nCXX="$(tc-getCXX)"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 194 # qmake bus errors with -O2 or -O3 but -O1 works
222 -i configure || die "sed qmake compilers failed" 195 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
223 # bug 321335 196 replace-flags -O[23] -O1
224 if version_is_at_least 4.6; then
225 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \
226 xargs -0 \
227 sed -e "s:\(\$MAKE\):\1 CC="$(tc-getCC)" CXX="$(tc-getCXX)" LD="$(tc-getCXX)" LINK="$(tc-getCXX)":g" \
228 -i || die "sed test compilers failed"
229 fi 197 fi
198
199 # Bug 417105
200 # graphite on gcc 4.7 causes miscompilations
201 if [[ $(gcc-version) == "4.7" ]]; then
202 filter-flags -fgraphite-identity
203 fi
204
205 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
206 sed -e "/^SYSTEM_VARIABLES=/i \
207 CC='$(tc-getCC)'\n\
208 CXX='$(tc-getCXX)'\n\
209 CFLAGS='${CFLAGS}'\n\
210 CXXFLAGS='${CXXFLAGS}'\n\
211 LDFLAGS='${LDFLAGS}'\n\
212 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
213 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
214 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
215 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
216 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
217 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
218 -i configure \
219 || die "sed SYSTEM_VARIABLES failed"
220
221 # Respect CC, CXX, LINK and *FLAGS in config.tests
222 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
223 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
224 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
225 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
226 || die "sed config.tests failed"
230 227
231 # Bug 172219 228 # Bug 172219
232 sed -e "s:X11R6/::" \ 229 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
233 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
234 230
235 if [[ ${CHOST} == *-darwin* ]]; then 231 if [[ ${CHOST} == *-darwin* ]]; then
236 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 232 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
237 # crippled (by design) :/ 233 # crippled (by design) :/
234 local mac_gpp_conf=
235 if [[ -f mkspecs/common/mac-g++.conf ]]; then
236 # qt < 4.8 has mac-g++.conf
237 mac_gpp_conf="mkspecs/common/mac-g++.conf"
238 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
239 # qt >= 4.8 has g++-macx.conf
240 mac_gpp_conf="mkspecs/common/g++-macx.conf"
241 else
242 die "no known conf file for mac found"
243 fi
244 sed \
238 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 245 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
239 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 246 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
240 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 247 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
241 -e "s:-arch\s\w*::g" \ 248 -e "s:-arch\s\w*::g" \
242 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 249 -i ${mac_gpp_conf} \
250 || die "sed ${mac_gpp_conf} failed"
243 251
244 # Fix configure's -arch settings that appear in qmake/Makefile and also 252 # Fix configure's -arch settings that appear in qmake/Makefile and also
245 # fix arch handling (automagically duplicates our -arch arg and breaks 253 # fix arch handling (automagically duplicates our -arch arg and breaks
246 # pch). Additionally disable Xarch support. 254 # pch). Additionally disable Xarch support.
255 local mac_gcc_confs="${mac_gpp_conf}"
256 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
257 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
258 fi
247 sed \ 259 sed \
248 -e "s:-arch i386::" \ 260 -e "s:-arch i386::" \
249 -e "s:-arch ppc::" \ 261 -e "s:-arch ppc::" \
250 -e "s:-arch x86_64::" \ 262 -e "s:-arch x86_64::" \
251 -e "s:-arch ppc64::" \ 263 -e "s:-arch ppc64::" \
252 -e "s:-arch \$i::" \ 264 -e "s:-arch \$i::" \
253 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 265 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
254 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 266 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
255 -e "s:-Xarch_x86_64::g" \ 267 -e "s:-Xarch_x86_64::g" \
256 -e "s:-Xarch_ppc64::g" \ 268 -e "s:-Xarch_ppc64::g" \
257 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 269 -i configure ${mac_gcc_confs} \
270 || die "sed -arch/-Xarch failed"
258 271
259 # On Snow Leopard don't fall back to 10.5 deployment target. 272 # On Snow Leopard don't fall back to 10.5 deployment target.
260 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 273 if [[ ${CHOST} == *-apple-darwin10 ]]; then
261 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 274 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
262 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 275 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
263 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 276 -i configure ${mac_gpp_conf} \
277 || die "sed deployment target failed"
264 fi 278 fi
265 fi 279 fi
266 280
267 # this one is needed for all systems with a separate -liconv, apart from 281 # this one is needed for all systems with a separate -liconv, apart from
268 # Darwin, for which the sources already cater for -liconv 282 # Darwin, for which the sources already cater for -liconv
269 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 283 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
270 sed \ 284 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
271 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
272 -i config.tests/unix/iconv/iconv.pro \ 285 -i config.tests/unix/iconv/iconv.pro \
273 || die "sed on iconv.pro failed" 286 || die "sed iconv.pro failed"
274 fi 287 fi
275 288
276 # we need some patches for Solaris 289 # we need some patches for Solaris
277 sed -i \
278 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 290 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
279 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 291 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
280 # use GCC over SunStudio 292 # use GCC over SunStudio
281 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 293 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
282 # don't flirt with non-Prefix stuff, we're quite possessive 294 # do not flirt with non-Prefix stuff, we're quite possessive
283 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 295 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
284 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 296 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
285 # strip predefined CFLAGS from qmake ( bug #312689 )
286 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
287 297
288 base_src_prepare 298 # apply patches
299 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
300 epatch_user
289} 301}
290 302
291# @FUNCTION: qt4-build_src_configure 303# @FUNCTION: qt4-build_src_configure
292# @DESCRIPTION: 304# @DESCRIPTION:
293# Default configure phase 305# Default configure phase
294qt4-build_src_configure() { 306qt4-build_src_configure() {
295 setqtenv 307 setqtenv
296 myconf="$(standard_configure_options) ${myconf}" 308
309 local conf="
310 -prefix ${QTPREFIXDIR}
311 -bindir ${QTBINDIR}
312 -libdir ${QTLIBDIR}
313 -docdir ${QTDOCDIR}
314 -headerdir ${QTHEADERDIR}
315 -plugindir ${QTPLUGINDIR}
316 -importdir ${QTIMPORTDIR}
317 -datadir ${QTDATADIR}
318 -translationdir ${QTTRANSDIR}
319 -sysconfdir ${QTSYSCONFDIR}
320 -examplesdir ${QTEXAMPLESDIR}
321 -demosdir ${QTDEMOSDIR}
322 -opensource -confirm-license
323 -shared -fast -largefile -stl -verbose
324 -nomake examples -nomake demos"
325
326 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
327 # $(tc-arch). Therefore we convert it to supported values.
328 case "$(tc-arch)" in
329 amd64|x64-*) conf+=" -arch x86_64" ;;
330 ppc-macos) conf+=" -arch ppc" ;;
331 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
332 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
333 x86-macos) conf+=" -arch x86" ;;
334 x86|x86-*) conf+=" -arch i386" ;;
335 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
336 hppa|sh) conf+=" -arch generic" ;;
337 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
338 esac
339
340 conf+=" -platform $(qt_mkspecs_dir)"
341
342 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
343
344 # debug/release
345 if use debug; then
346 conf+=" -debug"
347 else
348 conf+=" -release"
349 fi
350 conf+=" -no-separate-debug-info"
351
352 # exceptions USE flag
353 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
354
355 # disable rpath (bug 380415), except on prefix (bug 417169)
356 use prefix || conf+=" -no-rpath"
357
358 # precompiled headers don't work on hardened, where the flag is masked
359 conf+=" $(qt_use pch)"
360
361 # -reduce-relocations
362 # This flag seems to introduce major breakage to applications,
363 # mostly to be seen as a core dump with the message "QPixmap: Must
364 # construct a QApplication before a QPaintDevice" on Solaris.
365 # -- Daniel Vergien
366 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
297 367
298 # this one is needed for all systems with a separate -liconv, apart from 368 # this one is needed for all systems with a separate -liconv, apart from
299 # Darwin, for which the sources already cater for -liconv 369 # Darwin, for which the sources already cater for -liconv
300 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 370 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
301 myconf+=" -liconv" 371 conf+=" -liconv"
372 fi
302 373
303 if has glib ${IUSE//+} && use glib; then 374 if use_if_iuse glib; then
304 # use -I, -L and -l from configure
305 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 375 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
306 # avoid the -pthread argument 376 # avoid the -pthread argument
307 myconf+=" ${glibflags//-pthread}" 377 conf+=" ${glibflags//-pthread}"
308 unset glibflags 378 unset glibflags
309 fi 379 fi
310 380
311 if use aqua ; then 381 if use aqua; then
312 # On (snow) leopard use the new (frameworked) cocoa code. 382 # On (snow) leopard use the new (frameworked) cocoa code.
313 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 383 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
314 myconf+=" -cocoa -framework" 384 conf+=" -cocoa -framework"
385 # We need the source's headers, not the installed ones.
386 conf+=" -I${S}/include"
387 # Add hint for the framework location.
388 conf+=" -F${QTLIBDIR}"
315 389
316 # We are crazy and build cocoa + qt3support :-) 390 # We are crazy and build cocoa + qt3support :-)
317 if use qt3support; then 391 if use qt3support; then
318 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 392 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
319 -i configure 393 -i configure || die
320 fi 394 fi
321 395 else
322 # We need the source's headers, not the installed ones. 396 conf+=" -no-framework"
323 myconf+=" -I${S}/include"
324
325 # Add hint for the framework location.
326 myconf+=" -F${QTLIBDIR}"
327 fi 397 fi
328 else 398 else
329 # freetype2 include dir is non-standard, thus include it on configure 399 # freetype2 include dir is non-standard, thus pass it to configure
330 # use -I from configure
331 myconf+=" $(pkg-config --cflags freetype2)" 400 conf+=" $(pkg-config --cflags-only-I freetype2)"
332 fi 401 fi
333 402
334 # Disable SSE4.x, since auto-detection is currently broken 403 conf+=" ${myconf}"
335 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623 404 myconf=
336 if version_is_at_least 4.7.1; then
337 myconf+=" -no-sse4.1 -no-sse4.2"
338 fi
339 405
340 echo ./configure ${myconf} 406 echo ./configure ${conf}
341 ./configure ${myconf} || die "./configure failed" 407 ./configure ${conf} || die "./configure failed"
342 myconf="" 408
409 prepare_directories ${QT4_TARGET_DIRECTORIES}
343} 410}
344 411
345# @FUNCTION: qt4-build_src_compile 412# @FUNCTION: qt4-build_src_compile
413# @DESCRIPTION:
346# @DESCRIPTION: Actual compile phase 414# Actual compile phase
347qt4-build_src_compile() { 415qt4-build_src_compile() {
348 setqtenv 416 setqtenv
349 417
350 build_directories ${QT4_TARGET_DIRECTORIES} 418 build_directories ${QT4_TARGET_DIRECTORIES}
351} 419}
352 420
353# @FUNCTION: qt4-build_src_test 421# @FUNCTION: qt4-build_src_test
354# @DESCRIPTION: 422# @DESCRIPTION:
355# Runs tests only in target directories. 423# Runs tests only in target directories.
356qt4-build_src_test() { 424qt4-build_src_test() {
425 # QtMultimedia does not have any test suite (bug #332299)
426 [[ ${CATEGORY}/${PN} == dev-qt/qtmultimedia ]] && return
427
357 for dir in ${QT4_TARGET_DIRECTORIES}; do 428 for dir in ${QT4_TARGET_DIRECTORIES}; do
358 emake -j1 check -C ${dir} 429 emake -j1 check -C ${dir}
359 done 430 done
360} 431}
361 432
362# @FUNCTION: fix_includes 433# @FUNCTION: fix_includes
363# @DESCRIPTION: 434# @DESCRIPTION:
364# For MacOSX we need to add some symlinks when frameworks are 435# For MacOS X we need to add some symlinks when frameworks are
365# being used, to avoid complications with some more or less stupid packages. 436# being used, to avoid complications with some more or less stupid packages.
366fix_includes() { 437fix_includes() {
367 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 438 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
439 local frw dest f h rdir
368 # Some packages tend to include <Qt/...> 440 # Some packages tend to include <Qt/...>
369 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 441 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
370 442
371 # Fake normal headers when frameworks are installed... eases life later on 443 # Fake normal headers when frameworks are installed... eases life later
372 local dest f 444 # on, make sure we use relative links though, as some ebuilds assume
445 # these dirs exist in src_install to add additional files
446 f=${QTHEADERDIR}
447 h=${QTLIBDIR}
448 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
449 f=${f#*/}
450 h=${h#*/}
451 done
452 rdir=${h}
453 f="../"
454 while [[ ${h} == */* ]] ; do
455 f="${f}../"
456 h=${h#*/}
457 done
458 rdir="${f}${rdir}"
459
373 for frw in "${D}${QTLIBDIR}"/*.framework; do 460 for frw in "${D}${QTLIBDIR}"/*.framework; do
374 [[ -e "${frw}"/Headers ]] || continue 461 [[ -e "${frw}"/Headers ]] || continue
375 f=$(basename ${frw}) 462 f=$(basename ${frw})
376 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 463 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
377 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 464 dosym "${rdir}"/${f}/Headers "${dest}"
378 465
379 # Link normal headers as well. 466 # Link normal headers as well.
380 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 467 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
381 h=$(basename ${hdr}) 468 h=$(basename ${hdr})
382 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 469 dosym "../${rdir}"/${f}/Headers/${h} \
470 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
383 done 471 done
384 done 472 done
385 fi 473 fi
386} 474}
387 475
388# @FUNCTION: qt4-build_src_install 476# @FUNCTION: qt4-build_src_install
389# @DESCRIPTION: 477# @DESCRIPTION:
390# Perform the actual installation including some library fixes. 478# Perform the actual installation including some library fixes.
391qt4-build_src_install() { 479qt4-build_src_install() {
392 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
393 setqtenv 480 setqtenv
481
394 install_directories ${QT4_TARGET_DIRECTORIES} 482 install_directories ${QT4_TARGET_DIRECTORIES}
395 install_qconfigs 483 install_qconfigs
396 fix_library_files 484 fix_library_files
397 fix_includes 485 fix_includes
486
398 # remove .la files since we are building only shared Qt libraries 487 # remove .la files since we are building only shared libraries
399 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 488 prune_libtool_files
400} 489}
401 490
402# @FUNCTION: setqtenv 491# @FUNCTION: setqtenv
492# @INTERNAL
403setqtenv() { 493setqtenv() {
404 # Set up installation directories 494 # Set up installation directories
405 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
406 QTPREFIXDIR=${EPREFIX}/usr 495 QTPREFIXDIR=${EPREFIX}/usr
407 QTBINDIR=${EPREFIX}/usr/bin 496 QTBINDIR=${QTPREFIXDIR}/bin
408 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 497 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
409 QMAKE_LIBDIR_QT=${QTLIBDIR}
410 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 498 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
411 QTDATADIR=${EPREFIX}/usr/share/qt4
412 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 499 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
413 QTHEADERDIR=${EPREFIX}/usr/include/qt4 500 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
414 QTPLUGINDIR=${QTLIBDIR}/plugins 501 QTPLUGINDIR=${QTLIBDIR}/plugins
502 QTIMPORTDIR=${QTLIBDIR}/imports
503 QTDATADIR=${QTPREFIXDIR}/share/qt4
504 QTTRANSDIR=${QTDATADIR}/translations
415 QTSYSCONFDIR=${EPREFIX}/etc/qt4 505 QTSYSCONFDIR=${EPREFIX}/etc/qt4
416 QTTRANSDIR=${QTDATADIR}/translations
417 QTEXAMPLESDIR=${QTDATADIR}/examples 506 QTEXAMPLESDIR=${QTDATADIR}/examples
418 QTDEMOSDIR=${QTDATADIR}/demos 507 QTDEMOSDIR=${QTDATADIR}/demos
419 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 508 QMAKE_LIBDIR_QT=${QTLIBDIR}
509
420 PLATFORM=$(qt_mkspecs_dir) 510 PLATFORM=$(qt_mkspecs_dir)
421
422 unset QMAKESPEC 511 unset QMAKESPEC
423}
424 512
425# @FUNCTION: standard_configure_options 513 export XDG_CONFIG_HOME="${T}"
426# @DESCRIPTION: 514}
427# Sets up some standard configure options, like libdir (if necessary), whether
428# debug info is wanted or not.
429standard_configure_options() {
430 local myconf=
431 515
432 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)" 516# @FUNCTION: prepare_directories
433 517# @USAGE: < directories >
434 # Disable visibility explicitly if gcc version isn't 4 518# @INTERNAL
435 if [[ $(gcc-major-version) -lt 4 ]]; then 519# @DESCRIPTION:
436 myconf+=" -no-reduce-exports" 520# Generates Makefiles for the given list of directories.
437 fi 521prepare_directories() {
438 522 for x in "$@"; do
439 # precompiled headers doesn't work on hardened, where the flag is masked. 523 pushd "${S}"/${x} >/dev/null || die
440 myconf+=" $(qt_use pch)" 524 einfo "Running qmake in: ${x}"
441 525 "${S}"/bin/qmake \
442 if use debug; then 526 "LIBS+=-L${QTLIBDIR}" \
443 myconf+=" -debug" 527 "CONFIG+=nostrip" \
444 else 528 || die "qmake failed"
445 myconf+=" -release" 529 popd >/dev/null || die
446 fi 530 done
447 myconf+=" -no-separate-debug-info"
448
449 use aqua && myconf+=" -no-framework"
450
451 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
452 # $(tc-arch). Therefore we convert it to supported values.
453 case "$(tc-arch)" in
454 amd64|x64-*) myconf+=" -arch x86_64" ;;
455 ppc-macos) myconf+=" -arch ppc" ;;
456 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
457 sparc|sparc-*) myconf+=" -arch sparc" ;;
458 x86-macos) myconf+=" -arch x86" ;;
459 x86|x86-*) myconf+=" -arch i386" ;;
460 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
461 hppa|sh) myconf+=" -arch generic" ;;
462 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
463 esac
464
465 # 4.5: build everything but qt-xmlpatterns w/o exceptions
466 # 4.6: exceptions USE flag
467 local exceptions="-exceptions"
468 case "${PV}" in
469 4.5.*)
470 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
471 ;;
472 *)
473 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
474 ;;
475 esac
476
477 # note about -reduce-relocations:
478 # That flag seems to introduce major breakage to applications,
479 # mostly to be seen as a core dump with the message "QPixmap: Must
480 # construct a QApplication before a QPaintDevice" on Solaris
481 # -- Daniel Vergien
482 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
483
484 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
485 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
486 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
487 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
488 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
489 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
490 ${exceptions}
491 -nomake examples -nomake demos"
492
493 echo "${myconf}"
494} 531}
495 532
496# @FUNCTION: build_directories 533# @FUNCTION: build_directories
497# @USAGE: < directories > 534# @USAGE: < directories >
535# @INTERNAL
498# @DESCRIPTION: 536# @DESCRIPTION:
499# Compiles the code in $QT4_TARGET_DIRECTORIES 537# Compiles the code in the given list of directories.
500build_directories() { 538build_directories() {
501 for x in "$@"; do 539 for x in "$@"; do
502 pushd "${S}"/${x} >/dev/null 540 pushd "${S}"/${x} >/dev/null || die
503 # avoid running over the maximum argument number, bug #299810 541 emake \
504 { 542 AR="$(tc-getAR) cqs" \
505 echo "${S}"/mkspecs/common/*.conf
506 find "${S}" -name '*.pr[io]'
507 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die
508 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
509 emake CC="$(tc-getCC)" \ 543 CC="$(tc-getCC)" \
510 CXX="$(tc-getCXX)" \ 544 CXX="$(tc-getCXX)" \
511 LINK="$(tc-getCXX)" || die "emake failed" 545 LINK="$(tc-getCXX)" \
546 RANLIB=":" \
547 STRIP=":"
512 popd >/dev/null 548 popd >/dev/null || die
513 done 549 done
514} 550}
515 551
516# @FUNCTION: install_directories 552# @FUNCTION: install_directories
517# @USAGE: < directories > 553# @USAGE: < directories >
554# @INTERNAL
518# @DESCRIPTION: 555# @DESCRIPTION:
519# run emake install in the given directories, which are separated by spaces 556# Runs emake install in the given directories, which are separated by spaces.
520install_directories() { 557install_directories() {
521 for x in "$@"; do 558 for x in "$@"; do
522 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 559 pushd "${S}"/${x} >/dev/null || die
523 emake INSTALL_ROOT="${D}" install || die "emake install failed" 560 emake INSTALL_ROOT="${D}" install
524 popd >/dev/null || die "Can't popd from ${S}/${x}" 561 popd >/dev/null || die
525 done 562 done
526} 563}
527 564
528# @ECLASS-VARIABLE: QCONFIG_ADD 565# @ECLASS-VARIABLE: QCONFIG_ADD
529# @DESCRIPTION: 566# @DESCRIPTION:
539# @DESCRIPTION: 576# @DESCRIPTION:
540# List variables that should be defined at the top of QtCore/qconfig.h 577# List variables that should be defined at the top of QtCore/qconfig.h
541: ${QCONFIG_DEFINE:=} 578: ${QCONFIG_DEFINE:=}
542 579
543# @FUNCTION: install_qconfigs 580# @FUNCTION: install_qconfigs
581# @INTERNAL
582# @DESCRIPTION:
544# @DESCRIPTION: Install gentoo-specific mkspecs configurations 583# Install gentoo-specific mkspecs configurations.
545install_qconfigs() { 584install_qconfigs() {
546 local x 585 local x
547 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 586 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
548 for x in QCONFIG_ADD QCONFIG_REMOVE; do 587 for x in QCONFIG_ADD QCONFIG_REMOVE; do
549 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 588 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
550 done 589 done
551 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo 590 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
552 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 591 doins "${T}"/${PN}-qconfig.pri
553 fi 592 fi
554 593
555 if [[ -n ${QCONFIG_DEFINE} ]]; then 594 if [[ -n ${QCONFIG_DEFINE} ]]; then
556 for x in ${QCONFIG_DEFINE}; do 595 for x in ${QCONFIG_DEFINE}; do
557 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 596 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
558 done 597 done
559 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo 598 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
560 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 599 doins "${T}"/gentoo-${PN}-qconfig.h
561 fi 600 fi
562} 601}
563 602
564# @FUNCTION: generate_qconfigs 603# @FUNCTION: generate_qconfigs
565# @DESCRIPTION: Generates gentoo-specific configurations 604# @INTERNAL
605# @DESCRIPTION:
606# Generates gentoo-specific qconfig.{h,pri}.
566generate_qconfigs() { 607generate_qconfigs() {
567 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 608 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == dev-qt/qtcore ]]; then
568 local x qconfig_add qconfig_remove qconfig_new 609 local x qconfig_add qconfig_remove qconfig_new
569 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 610 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
570 [[ -f ${x} ]] || continue 611 [[ -f ${x} ]] || continue
571 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 612 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
572 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 613 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
573 done 614 done
574 615
575 # these error checks do not use die because dying in pkg_post{inst,rm} 616 # these error checks do not use die because dying in pkg_post{inst,rm}
576 # just makes things worse. 617 # just makes things worse.
577 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 618 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
578 # start with the qconfig.pri that qt-core installed 619 # start with the qconfig.pri that qtcore installed
579 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \ 620 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
580 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 621 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
581 eerror "cp qconfig failed." 622 eerror "cp qconfig failed."
582 return 1 623 return 1
583 fi 624 fi
584 625
585 # generate list of QT_CONFIG entries from the existing list 626 # generate list of QT_CONFIG entries from the existing list
586 # including qconfig_add and excluding qconfig_remove 627 # including qconfig_add and excluding qconfig_remove
587 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 628 for x in $(sed -n 's/^QT_CONFIG +=//p' \
588 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 629 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
589 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 630 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
590 done 631 done
591 632
592 # replace the existing QT_CONFIG list with qconfig_new 633 # replace the existing QT_CONFIG list with qconfig_new
593 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 634 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
594 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 635 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
618 fi 659 fi
619 fi 660 fi
620} 661}
621 662
622# @FUNCTION: qt4-build_pkg_postrm 663# @FUNCTION: qt4-build_pkg_postrm
664# @DESCRIPTION:
623# @DESCRIPTION: Generate configurations when the package is completely removed 665# Regenerate configuration when the package is completely removed.
624qt4-build_pkg_postrm() { 666qt4-build_pkg_postrm() {
625 generate_qconfigs 667 generate_qconfigs
626} 668}
627 669
628# @FUNCTION: qt4-build_pkg_postinst 670# @FUNCTION: qt4-build_pkg_postinst
671# @DESCRIPTION:
629# @DESCRIPTION: Generate configuration, plus throws a message about possible 672# Regenerate configuration, plus throw a message about possible
630# breakages and proposed solutions. 673# breakages and proposed solutions.
631qt4-build_pkg_postinst() { 674qt4-build_pkg_postinst() {
632 generate_qconfigs 675 generate_qconfigs
633} 676}
634 677
635# @FUNCTION: skip_qmake_build_patch 678# @FUNCTION: skip_qmake_build
679# @INTERNAL
636# @DESCRIPTION: 680# @DESCRIPTION:
637# Don't need to build qmake, as it's already installed from qt-core 681# Patches configure to skip qmake compilation, as it's already installed by qtcore.
638skip_qmake_build_patch() { 682skip_qmake_build() {
639 # Don't need to build qmake, as it's already installed from qt-core
640 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 683 sed -i -e "s:if true:if false:g" "${S}"/configure || die
641} 684}
642 685
643# @FUNCTION: skip_project_generation_patch 686# @FUNCTION: skip_project_generation
687# @INTERNAL
644# @DESCRIPTION: 688# @DESCRIPTION:
645# Exit the script early by throwing in an exit before all of the .pro files are scanned 689# Exit the script early by throwing in an exit before all of the .pro files are scanned.
646skip_project_generation_patch() { 690skip_project_generation() {
647 # Exit the script early by throwing in an exit before all of the .pro files are scanned
648 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 691 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
649 -i "${S}"/configure || die "Sed failed"
650} 692}
651 693
652# @FUNCTION: symlink_binaries_to_buildtree 694# @FUNCTION: symlink_binaries_to_buildtree
695# @INTERNAL
653# @DESCRIPTION: 696# @DESCRIPTION:
654# Symlink generated binaries to buildtree so they can be used during compilation 697# Symlinks generated binaries to buildtree, so they can be used during compilation time.
655# time
656symlink_binaries_to_buildtree() { 698symlink_binaries_to_buildtree() {
657 for bin in qmake moc uic rcc; do 699 for bin in qmake moc uic rcc; do
658 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 700 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
659 done 701 done
660} 702}
661 703
662# @FUNCTION: fix_library_files 704# @FUNCTION: fix_library_files
705# @INTERNAL
663# @DESCRIPTION: 706# @DESCRIPTION:
664# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 707# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
665# moves the *.pc-files into the pkgconfig directory 708# moves the *.pc files into the pkgconfig directory.
666fix_library_files() { 709fix_library_files() {
710 local libfile
667 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 711 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
668 if [[ -e ${libfile} ]]; then 712 if [[ -e ${libfile} ]]; then
669 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 713 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
670 fi 714 fi
671 done 715 done
672 716
673 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 717 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
674 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 718 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
675 if [[ -e ${libfile} ]]; then 719 if [[ -e ${libfile} ]]; then
676 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 720 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
677 721
678 # Move .pc files into the pkgconfig directory 722 # Move .pc files into the pkgconfig directory
679 dodir ${QTPCDIR#${EPREFIX}} 723 dodir ${QTPCDIR#${EPREFIX}}
680 mv ${libfile} "${D}"/${QTPCDIR}/ \ 724 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
681 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
682 fi 725 fi
683 done 726 done
684 727
685 # Don't install an empty directory 728 # Don't install an empty directory
686 rmdir "${D}"/${QTLIBDIR}/pkgconfig 729 rmdir "${D}"/${QTLIBDIR}/pkgconfig
687} 730}
688 731
689# @FUNCTION: qt_use 732# @FUNCTION: qt_use
690# @USAGE: < flag > [ feature ] [ enableval ] 733# @USAGE: < flag > [ feature ] [ enableval ]
691# @DESCRIPTION: 734# @DESCRIPTION:
692# This will echo "${enableval}-${feature}" if <flag> is enabled, or 735# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
693# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 736# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
694# will be used for that. If [enableval] is not specified, it omits the 737# will be used for that. If [enableval] is not specified, it omits the
695# assignment-part 738# "-${enableval}" part.
696qt_use() { 739qt_use() {
697 local flag=$1 740 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
698 local feature=$1
699 local enableval=
700
701 [[ -n $2 ]] && feature=$2
702 [[ -n $3 ]] && enableval=-$3
703
704 if use ${flag}; then
705 echo "${enableval}-${feature}"
706 else
707 echo "-no-${feature}"
708 fi
709} 741}
710 742
711# @FUNCTION: qt_mkspecs_dir 743# @FUNCTION: qt_mkspecs_dir
712# @RETURN: the specs-directory w/o path 744# @RETURN: the specs-directory w/o path
713# @DESCRIPTION: 745# @DESCRIPTION:
714# Allows us to define which mkspecs dir we want to use. 746# Allows us to define which mkspecs dir we want to use.
715qt_mkspecs_dir() { 747qt_mkspecs_dir() {
716 # Allows us to define which mkspecs dir we want to use.
717 local spec 748 local spec=
718 749
719 case ${CHOST} in 750 case "${CHOST}" in
720 *-freebsd*|*-dragonfly*) 751 *-freebsd*|*-dragonfly*)
721 spec=freebsd ;; 752 spec=freebsd ;;
722 *-openbsd*) 753 *-openbsd*)
723 spec=openbsd ;; 754 spec=openbsd ;;
724 *-netbsd*) 755 *-netbsd*)
735 *-solaris*) 766 *-solaris*)
736 spec=solaris ;; 767 spec=solaris ;;
737 *-linux-*|*-linux) 768 *-linux-*|*-linux)
738 spec=linux ;; 769 spec=linux ;;
739 *) 770 *)
740 die "Unknown CHOST, no platform choosen." 771 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
741 esac 772 esac
742 773
743 CXX=$(tc-getCXX) 774 case "$(tc-getCXX)" in
744 if [[ ${CXX} == *g++* ]]; then 775 *g++*)
745 spec+=-g++ 776 spec+=-g++ ;;
746 elif [[ ${CXX} == *icpc* ]]; then 777 *icpc*)
747 spec+=-icc 778 spec+=-icc ;;
748 else 779 *)
749 die "Unknown compiler ${CXX}." 780 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
750 fi 781 esac
751 if [[ -n ${LIBDIR/lib} ]]; then
752 spec+=-${LIBDIR/lib}
753 fi
754 782
755 # Add -64 for 64bit profiles 783 # Add -64 for 64bit profiles
756 if use x64-freebsd || 784 if use x64-freebsd ||
757 use amd64-linux || 785 use amd64-linux ||
758 use x64-macos || 786 use x64-macos ||
763 fi 791 fi
764 792
765 echo "${spec}" 793 echo "${spec}"
766} 794}
767 795
768# @FUNCTION: qt_assistant_cleanup
769# @RETURN: nothing
770# @DESCRIPTION:
771# Tries to clean up tools.pro for qt-assistant ebuilds
772# Meant to be called in src_prepare
773qt_assistant_cleanup() {
774 # different versions (and branches...) may need different handling,
775 # add a case if you need special handling
776 case "${MY_PV_EXTRA}" in
777 *kde-qt*)
778 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
779 -e "/mac/,/^embedded.*makeqpf$/d" \
780 -i tools/tools.pro || die "patching tools.pro failed"
781 ;;
782 *)
783 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
784 -e "/mac/,/^embedded.*makeqpf$/d" \
785 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
786 -i tools/tools.pro || die "patching tools.pro failed"
787 ;;
788 esac
789}
790
791# @FUNCTION: qt_nolibx11 796# @FUNCTION: qt_nolibx11
792# @RETURN: nothing 797# @INTERNAL
793# @DESCRIPTION: 798# @DESCRIPTION:
794# Ignore X11 tests for packages that don't need X libraries installed 799# Skip X11 tests for packages that don't need X libraries installed.
795qt_nolibx11() { 800qt_nolibx11() {
796 einfo "removing X11 check to allow X-less compilation" 801 sed -i -e '/^if.*PLATFORM_X11.*CFG_GUI/,/^fi$/d' "${S}"/configure || die
797 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
798 die "x11 check sed failed"
799} 802}
800 803
801EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 804EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.85  
changed lines
  Added in v.1.150

  ViewVC Help
Powered by ViewVC 1.1.20